package constraints {
	
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.utils.Dictionary;
	
	import org.cove.ape.APEngine;
	import org.cove.ape.CircleParticle;
	import org.cove.ape.Group;
	import org.cove.ape.RectangleParticle;
	import org.cove.ape.SpringConstraint;
	import org.cove.ape.Vector;

	public class Constraints2 extends MovieClip {
		
		private var anchor:CircleParticle;
		private var springiness:Number = 0.9;
		private var springAlpha:Number = 0.5
		private var circleRadius:Number = 25;
		private var friction:Number = 1;
		private var selectedCircle:CircleParticle;
		private var dictionary:Dictionary = new Dictionary();
		
		public function Constraints2() {
			super();
			var circles:Array = new Array();
			
			trace("Constraints");
			APEngine.init(1/1.5);
			APEngine.container = this;
			APEngine.addMasslessForce(new Vector(0, 10));
			
			APEngine.damping = .9;
			//APEngine.constraintCollisionCycles = 5;
			
			var posX:Number = 200;
			var posY:Number = 100;
			
			var group:Group = new Group(true);
			
			anchor = new CircleParticle(posX, posY, circleRadius, false, 1, 0, friction);
			anchor.setStyle(0, 0x000000, 1, 0x000000, 1);			
			group.addParticle(anchor);
			circles.push(anchor);
			dictionary[anchor.sprite] = anchor;
			
			var circle1:CircleParticle = new CircleParticle(posX - 100, posY - 100, circleRadius, false, 1, 0, friction);
			circle1.setStyle(0, 0x000000, 1, 0x000000, 1);
			group.addParticle(circle1);
			circles.push(circle1);
			dictionary[circle1.sprite] = circle1;
			
			var circle2:CircleParticle = new CircleParticle(posX, posY - 100, circleRadius, false, 1, 0, friction);
			circle2.setStyle(0, 0x000000, 1, 0x000000, 1);
			group.addParticle(circle2);
			circles.push(circle2);
			dictionary[circle2.sprite] = circle2;
			
			var circle3:CircleParticle = new CircleParticle(posX + 100, posY - 100, circleRadius, false, 1, 0, friction);
			circle3.setStyle(0, 0x000000, 1, 0x000000, 1);
			group.addParticle(circle3);
			circles.push(circle3);
			dictionary[circle3.sprite] = circle3;
			
			var circle4:CircleParticle = new CircleParticle(posX - 100, posY, circleRadius, false, 1, 0, friction);
			circle4.setStyle(0, 0x000000, 1, 0x000000, 1);
			group.addParticle(circle4);
			circles.push(circle4);
			dictionary[circle4.sprite] = circle4;
			
			var circle5:CircleParticle = new CircleParticle(posX + 100, posY, circleRadius, false, 1, 0, friction);
			circle5.setStyle(0, 0x000000, 1, 0x000000, 1);
			group.addParticle(circle5);
			circles.push(circle5);
			dictionary[circle5.sprite] = circle5;
			
			var circle6:CircleParticle = new CircleParticle(posX - 100, posY + 100, circleRadius, false, 1, 0, friction);
			circle6.setStyle(0, 0x000000, 1, 0x000000, 1);
			group.addParticle(circle6);
			circles.push(circle6);
			dictionary[circle6.sprite] = circle6;
			
			var circle7:CircleParticle = new CircleParticle(posX, posY + 100, circleRadius, false, 1, 0, friction);
			circle7.setStyle(0, 0x000000, 1, 0x000000, 1);
			group.addParticle(circle7);
			circles.push(circle7);
			dictionary[circle7.sprite] = circle7;
			
			var circle8:CircleParticle = new CircleParticle(posX + 100, posY + 100, circleRadius, false, 1, 0, friction);
			circle8.setStyle(0, 0x000000, 1, 0x000000, 1);
			group.addParticle(circle8);
			circles.push(circle8);
			dictionary[circle8.sprite] = circle8;
			
			var constraint1:SpringConstraint = new SpringConstraint(anchor, circle1, springiness);
			constraint1.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(constraint1);
			
			var constraint2:SpringConstraint = new SpringConstraint(anchor, circle2, springiness);
			constraint2.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(constraint2);
			
			var constraint3:SpringConstraint = new SpringConstraint(anchor, circle3, springiness);
			constraint3.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(constraint3);
			
			var constraint4:SpringConstraint = new SpringConstraint(anchor, circle4, springiness);
			constraint4.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(constraint4);
			
			var constraint5:SpringConstraint = new SpringConstraint(anchor, circle5, springiness);
			constraint5.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(constraint5);
			
			var constraint6:SpringConstraint = new SpringConstraint(anchor, circle6, springiness);
			constraint6.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(constraint6);
			
			var constraint7:SpringConstraint = new SpringConstraint(anchor, circle7, springiness);
			constraint7.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(constraint7);
			
			
			var constraint8:SpringConstraint = new SpringConstraint(anchor, circle8, springiness);
			constraint8.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(constraint8);
			
			var spring1:SpringConstraint = new SpringConstraint(circle1, circle2, springiness);
			spring1.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(spring1);
			
			var spring2:SpringConstraint = new SpringConstraint(circle2, circle3, springiness);
			spring2.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(spring2);
			
			var spring3:SpringConstraint = new SpringConstraint(circle1, circle4, springiness);
			spring3.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(spring3);
			
			var spring4:SpringConstraint = new SpringConstraint(circle3, circle5, springiness);
			spring4.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(spring4);
			
			var spring5:SpringConstraint = new SpringConstraint(circle4, circle6, springiness);
			spring5.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(spring5);
			
			var spring6:SpringConstraint = new SpringConstraint(circle6, circle7, springiness);
			spring6.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(spring6);
			
			var spring7:SpringConstraint = new SpringConstraint(circle7, circle8, springiness);
			spring7.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(spring7);
			
			var spring8:SpringConstraint = new SpringConstraint(circle5, circle8, springiness);
			spring8.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(spring8);
			
			var diagonal1:SpringConstraint = new SpringConstraint(circle4, circle2, springiness);
			diagonal1.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(diagonal1);
			
			var diagonal2:SpringConstraint = new SpringConstraint(circle2, circle5, springiness);
			diagonal2.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(diagonal2);
			
			var diagonal3:SpringConstraint = new SpringConstraint(circle5, circle7, springiness);
			diagonal3.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(diagonal3);
			
			var diagonal4:SpringConstraint = new SpringConstraint(circle4, circle7, springiness);
			diagonal4.setStyle(0, 0x000000, springAlpha);
			group.addConstraint(diagonal4);
			
			var floor1:RectangleParticle = new RectangleParticle(-50, 450, 600, 100, 0, true, 5, 1, 0);
			floor1.setStyle(0, 0, 0, 0x999999);
			group.addParticle(floor1);
			
			var floor2:RectangleParticle = new RectangleParticle(300, 550, 300, 100, 0, true, 5, 1, 0);
			floor2.setStyle(0, 0, 0, 0x999999);
			group.addParticle(floor2);
			
			var floor3:RectangleParticle = new RectangleParticle(500, 650, 300, 100, 0, true, 5, 1, 0);
			floor3.setStyle(0, 0, 0, 0x999999);
			group.addParticle(floor3);
			
			var floor4:RectangleParticle = new RectangleParticle(800, 750, 600, 100, 0, true, 5, 1, 0);
			floor4.setStyle(0, 0, 0, 0x999999);
			group.addParticle(floor4);
			
			APEngine.addGroup(group);
			
			for each(var circle:CircleParticle in circles) {
				circle.sprite.addEventListener(MouseEvent.MOUSE_DOWN, circleParticleMouseDownHandler);
			}
			
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
		}
		
		private function circleParticleMouseDownHandler(event:MouseEvent):void {
			addEventListener(Event.ENTER_FRAME, moveBall);
			stage.addEventListener(MouseEvent.MOUSE_UP, stageMouseUpHandler);
			selectedCircle = dictionary[event.target];
		}
		
		private function moveBall(event:Event):void {
			selectedCircle.px = mouseX;
			selectedCircle.py = mouseY;
		}
		
		private function stageMouseUpHandler(event:MouseEvent):void {
			removeEventListener(Event.ENTER_FRAME, moveBall);
			stage.removeEventListener(MouseEvent.MOUSE_UP, stageMouseUpHandler);
		}
		
		private function enterFrameHandler(evt:Event):void {
			APEngine.step();
			APEngine.paint();
		}
		
	}
	
}