package pendulum {
	
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import org.cove.ape.APEngine;
	import org.cove.ape.CircleParticle;
	import org.cove.ape.Group;
	import org.cove.ape.RectangleParticle;
	import org.cove.ape.SpringConstraint;
	import org.cove.ape.Vector;

	public class Pendulum extends MovieClip {
		
		private var circleParticle:CircleParticle; 
		
		public function Pendulum() {
			super();
			trace("Pendulum");
			
			APEngine.init(1/2);
			APEngine.container = this;
			APEngine.addMasslessForce(new Vector(0, 10));
			
			APEngine.damping = .99;
			//APEngine.constraintCollisionCycles = 10;
			
			var group:Group = new Group(true);
			
			var anchor:CircleParticle = new CircleParticle(300, 50, 20, true, 1, 0.5, 0);
			anchor.setStyle(0, 0x000000, 1, 0x000000, 1);
			group.addParticle(anchor);
			
			circleParticle = new CircleParticle(30, 30, 30, false, 1, 0.5, 0);
			circleParticle.velocity = new Vector(4, 5);
			circleParticle.setStyle(0, 0x000000, 1, 0x000000, 1);
			group.addParticle(circleParticle);
			circleParticle.sprite.addEventListener(MouseEvent.MOUSE_DOWN, circleParticleMouseDownHandler);
			
			var block:RectangleParticle = new RectangleParticle(350, 300, 100, 200, 0, true, 5, 0.3, 0);
			block.setStyle(0, 0x000000, 1, 0x000000, 1);
			group.addParticle(block);
			
			var floor3:RectangleParticle = new RectangleParticle(350, 500, 700, 100, 0, true, 5, 1, 0);
			floor3.setStyle(0, 0, 0, 0x999999);
			group.addParticle(floor3);
			
			var constraint:SpringConstraint = new SpringConstraint(anchor, circleParticle, 0.1, false, 2, 2, false);
			group.addConstraint(constraint);
			
			APEngine.addGroup(group);
			
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
		}
		
		private function circleParticleMouseDownHandler(event:MouseEvent):void {
			addEventListener(Event.ENTER_FRAME, moveBall);
			stage.addEventListener(MouseEvent.MOUSE_UP, stageMouseUpHandler);
		}
		
		private function moveBall(event:Event):void {
			circleParticle.px = mouseX;
			circleParticle.py = mouseY;
		}
		
		private function stageMouseUpHandler(event:MouseEvent):void {
			removeEventListener(Event.ENTER_FRAME, moveBall);
			stage.removeEventListener(MouseEvent.MOUSE_UP, stageMouseUpHandler);
		}
		
		private function enterFrameHandler(evt:Event):void {
			APEngine.step();
			APEngine.paint();
		}
		
	}
	
}